#include <stdio.h>
#include <stdlib.h>
#include <dos.h>
#include <alloc.h>
#include <conio.h>
#include <string.h>

// generic flags
#define T_FLAG	0x00000001	// Terminate Flag, don't follow to the NEXT link
#define Q_FLAG	0x00000002	// Queue Head Flag, this link is that you follow next is a Queue Head, if 0, then Transfer Descriptor
// flags dealing with DW0 in the Transfer Descriptor
#define VF_FLAG 0x00000004	// Vertical Flag, do Depth first, of Breadth first on the Queue Heads
// flags dealing with DW1 in the Transfer Desctiptor
#define DW1_ACTIVE ( unsigned long)(0x1)<<23	// we set this to 1, the host controller clears it to 0, when done.
#define DW1_IOC		( unsigned long)(0x1)<<24	// interrupt on complete
#define DW1_ISO		( unsigned long)(0x1)<<25	// isochronous select
#define DW1_LS		( unsigned long)(0x1)<<26 // low speed device
#define DW1_C_ERR3	( unsigned long)(0x3)<<27	// error counter
#define DW1_C_ERR2	( unsigned long)(0x2)<<27	// error counter
#define DW1_C_ERR1	( unsigned long)(0x1)<<27	// error counter
#define DW1_SPD		( unsigned long)(0x1)<<28	// short packet detected used for IN transactions

// stuff dealing with DW2
#define DW2_IN		( unsigned long) 0x69
#define DW2_OUT	( unsigned long) 0xe1
#define DW2_SETUP	( unsigned long) 0x2d
#define DW2_DATA1_TOGGLE			( unsigned long)(0x01)<<19

// stuff dealing with Device Requests
// for get_protocol() or set_protocol()
#define BOOT_PROTOCOL					0
#define REPORT_PROTOCOL					1
// for clear_feature() or set_feature()
#define DEVICE_REMOTE_WAKEUP			1
#define ENDPOINT_STALL					0

// LED's
#define NUM_LOCK_ON						1
#define CAPS_LOCK_ON						2
#define SCROLL_LOCK_ON					4
// SOF packets are NOT transferred to low speed devices ( such as a keyboard)
// because they do not support isochronous transfers.

// MODIFIER KEYS
#define LEFT_CTRL							( unsigned long)(0x1)<<0
#define LEFT_SHIFT                  ( unsigned long)(0x1)<<1
#define LEFT_ALT                    ( unsigned long)(0x1)<<2
#define LEFT_GUI                    ( unsigned long)(0x1)<<3
#define RIGHT_CTRL                  ( unsigned long)(0x1)<<4
#define RIGHT_SHIFT                 ( unsigned long)(0x1)<<5
#define RIGHT_ALT                   ( unsigned long)(0x1)<<6
#define RIGHT_GUI                   ( unsigned long)(0x1)<<7

// ERROR CODES in bits 16-22
#define RESERVED_BIT16					( unsigned long)(0x1)<<16
#define BIT_STUFF_ERROR    			( unsigned long)(0x1)<<17
#define CRC_TIME_OUT_ERROR        	( unsigned long)(0x1)<<18
#define NAK           					( unsigned long)(0x1)<<19
#define BABBLE_ERROR  					( unsigned long)(0x1)<<20
#define DATA_BUFFER_ERROR           ( unsigned long)(0x1)<<21
#define STALLED_ERROR    				( unsigned long)(0x1)<<22


#define QUEUE_HEAD_TYPE					0
#define TRANSFER_DESCRIPTOR_TYPE 	1
#define FRAME_LIST_TYPE					2
#define DATA_TYPE							4
#define DW0_TYPE							5
#define DW1_TYPE							6
#define DW2_TYPE							7
#define DW3_TYPE							8
#define QH0_TYPE							9
#define QH1_TYPE							10
#define MAXBOX				46

void reset_usb_controller();
void print_status();
void next_transaction();
// mark add ich2
//void get_base_io();
void setup_framelist_and_queuehead();
int mouseon();
int mouseoff();
void getmouse();
void drawscreen();


int mousex, mousey, rightbutton, leftbutton;
char tempchar = ' ';
char tempattrib = 0x07;


unsigned char far *p;
unsigned long far *DW0, far *DW1, far *DW2, far *DW3;
unsigned long frame_list_base_address;
unsigned int frame_number;
unsigned long first_transfer_descriptor;
unsigned long first_queue_head;
unsigned long far *frame_pointer;
unsigned long far *queue_pointer;
unsigned long templ;
unsigned char current_transaction = 0;
unsigned char max_transaction = 7;
unsigned long QH1;

unsigned char far fredbuf[2048];
unsigned char far tempbuf[32];

union REGS regs;

unsigned char bus_num;
unsigned char device_func;

unsigned int base_io;

void main( int argc, char *argv[])
{
// mark add ich2 begin
        if ( argc != 2)
        {
                printf("USAGE: ich2 <base address>\n");
                return;
        }
        sscanf( argv[1], "%x", &base_io);
        printf("%X\n", base_io);

// mark add ich2 end
	textcolor( WHITE);
	textbackground( BLACK);
	clrscr();
// mark add ich2
//        get_base_io();
// we set the QUEUE HEAD 1 pointer to Terminate for pointing to the first
// Transfer Descriptor, plus the address of the TD.
// so to do a transaction, just set *(queue_pointer+1) = QH1
// cuz QH1 is the value WITHOUT the Terminate bit set.
	setup_framelist_and_queuehead();
// reset the USB controller, in case it's errored out last time.
	reset_usb_controller();
	drawscreen();
}

void setup_framelist_and_queuehead()
{
	// calculate offset into p, that's 4k aligned
	p = ( unsigned char far *)farmalloc( 16384); // room for 4 transfer descriptors and 1 Queue Head
	frame_list_base_address = FP_SEG( p);
	frame_list_base_address = frame_list_base_address << 4;
	frame_list_base_address = frame_list_base_address + FP_OFF( p);
	if ( frame_list_base_address != (frame_list_base_address & 0xfffff000L))
	{
		// if the frame_list_base_address is NOT 4k aligned already when
		// we allocate "p", then we shift it right 12 bits, to make mask out
		// the lower bits, add 1 to it, and then shift it back, this makes it
		// 4k aligned.
		frame_list_base_address = frame_list_base_address >> 12;
		frame_list_base_address++;
		frame_list_base_address = frame_list_base_address << 12;
	}
	printf("frame_list_base_address: %lX\n", frame_list_base_address);

	// we're gonna set up our first transfer descriptor to be right after
	// the 4k block of the frame list pointers, this makes the first transfer
	// descriptor 4k aligned, and it only needs dword alignment.
//	first_transfer_descriptor = frame_list_base_address;
//  	first_transfer_descriptor = first_transfer_descriptor>>12;
//	first_transfer_descriptor++;
//	first_transfer_descriptor = first_transfer_descriptor<<12;		// this puts us 4096 bytes past the array of 1024 pointers
	first_queue_head = frame_list_base_address;
	first_queue_head = first_queue_head>>12;
	first_queue_head++;
	first_queue_head = first_queue_head<<12;		// this puts us 4096 bytes past the array of 1024 pointers
	printf("first_queue_head: %lX\n",first_queue_head);
	queue_pointer = ( unsigned long far *) MK_FP ( (unsigned int)(first_queue_head>>4), 0);
//*queue_pointer = first_queue_head | Q_FLAG;
*queue_pointer = first_queue_head | Q_FLAG | T_FLAG;

	queue_pointer++;
	*queue_pointer = first_queue_head + 16 | VF_FLAG;
	QH1 = *queue_pointer;
	*queue_pointer = *queue_pointer | T_FLAG;
	queue_pointer--;
	printf("queue_pointer: %Fp\t*queue_pointer: %lX\n", queue_pointer, *queue_pointer);
	first_transfer_descriptor = first_queue_head + 16; // a queue head is 8 bytes
	printf("first_transfer_descriptor: %lX\n",first_transfer_descriptor);
	DW0 = ( unsigned long far *)MK_FP( ( unsigned int )(first_transfer_descriptor>>4), ( unsigned int)(first_transfer_descriptor & 0x000000f));
	DW1 = DW0 + 1;
	DW2 = DW0 + 2;
	DW3 = DW0 + 3;

	// make frame_pointer point to the first entry in the frame list pointer table.
	frame_pointer = ( unsigned long far *) MK_FP ( (unsigned int)(frame_list_base_address>>4), 0);
	printf("frame_pointer: %Fp\t", frame_pointer);
	// make frame_pointer point to the first_transfer_descriptor
// say we're a QUEUE HEAD
	*frame_pointer = first_queue_head | Q_FLAG;
	printf("*frame_pointer: %lX\n", *frame_pointer);

	for ( templ = 1; templ <= 1023; templ++)
	{
			*(frame_pointer+templ) = first_queue_head | Q_FLAG;
	}

}

// mark add ich2 begin
#if 0
void get_base_io()
{
	// find base I/O address of USB

	// check to see if PCI installed
	regs.x.ax = 0xb101;
	int86( 0x1a, &regs, &regs);
	if ( regs.x.cflag == 1)
	{
		printf("PCI ERROR (%X): PCI BIOS not installed, exiting\n", regs.h.ah);
		exit( 0);
	}

	// look specifically to see if PIIX4 is in the system
	regs.x.ax = 0xb102;
// mark add ich2
regs.x.cx = 0x7112;
//regs.x.cx = 0x7020;
	regs.x.dx = 0x8086;
	regs.x.si = 0x0000;
	int86( 0x1a, &regs, &regs);

	if ( regs.x.cflag == 1)
	{
		printf("PCI ERROR (%X): Unable to find PIIX4\n", regs.h.ah);
		exit( 0);
	}
	bus_num = regs.h.bh;
	device_func = regs.h.bl;

	printf("BUS: %X	DEV/FUN: %X\n", bus_num, device_func);

	// read the base address for the USB from the PIIX4
	regs.x.ax = 0xb109;
	regs.h.bl = device_func;
	regs.h.bh = bus_num;
	regs.x.di = 0x20;
	int86( 0x1a, &regs, &regs);
	if ( regs.x.cflag == 1)
	{
		printf("PCI ERROR (%X): unable to read base USB I/O address\n", regs.h.ah);
		exit( 0);
	}
	base_io = regs.x.cx;
	base_io = base_io & 0xFFFE;
	printf("Base I/O: %X\n", base_io);
}
#endif
// mark add ich2 end

void generic_setup( unsigned char address)
{
	address = address & 0x7f; // bits 8-14, not 8-15, so only 7 bits wide.
	// address goes into DW2, left shifted 8 bits

// FIRST TD
	*DW0 = first_transfer_descriptor + 16 | VF_FLAG;
// SECOND TD
	*(DW0 + 4) = first_transfer_descriptor + 32 | VF_FLAG;
// THIRD TD
	*(DW0 + 8)  = first_transfer_descriptor + 48 | VF_FLAG;
// FOURTH TD
	*(DW0 + 12)  = first_transfer_descriptor + 64 | VF_FLAG;
// FIFTH TD
	*(DW0 + 16)  = T_FLAG | VF_FLAG;

// FIRST TD
// added Low Speed device flag for ALL DW1's, since Microsoft Keyboard
// is a LS device, the Cherry keyboard is not.
	*DW1 = DW1_LS | DW1_C_ERR3;
// SECOND TD
	*(DW1 + 4) = DW1_LS | DW1_C_ERR3;
// THIRD TD
	*(DW1 + 8)  = DW1_LS | DW1_C_ERR3;
// FOURTH TD
	*(DW1 + 12)  = DW1_LS | DW1_C_ERR3;
// FIFTH TD
	*(DW1 + 16)  = DW1_LS | DW1_C_ERR3;

// FIRST TD
	*DW2 = DW2_SETUP | (unsigned long)(8-1)<<21 | (unsigned char)(address)<<8;
// SECOND TD
	*(DW2 + 4) = DW2_IN | DW2_DATA1_TOGGLE | (unsigned long) (8-1)<<21 | (unsigned char)(address)<<8;
// THIRD TD
	*(DW2 + 8)  = DW2_IN | (unsigned long) (8-1)<<21 | (unsigned char)(address)<<8;
// FOURTH TD
	*(DW2 + 12)  = DW2_IN | DW2_DATA1_TOGGLE | (unsigned long) (8-1)<<21 | (unsigned char)(address)<<8;
// FIFTH TD
// NOTE:!!!! FOR NULL PACKETS, YOU WILL ALWAYS CHOOSE DATA1 TOGGLED ON
// REGARDLESS OF THE CURRENT STATE OF DATA0 or DATA1!!!!
	*(DW2 + 16)  = DW2_OUT | DW2_DATA1_TOGGLE | (unsigned long) (0x7ff)<<21 | (unsigned char)(address)<<8;		// NULL PACKET

// FIRST TD
	*DW3 = FP_SEG( fredbuf);
	*DW3 = *DW3 << 4;
	*DW3 = *DW3 + FP_OFF( fredbuf);
// SECOND TD
// plus 8 bytes :)
	*(DW3 + 4) = *DW3 + 8;
// THIRD TD
// plus 8 bytes :)
	*(DW3 + 8) = *DW3 + 16;
// FOURTH TD
// plus 8 bytes :)
	*(DW3 + 12) = *DW3 + 24;
// FIFTH TD
// plus 8 bytes :)
	*(DW3 + 16) = *DW3 + 32;

	fredbuf[0] = 0x80;	// Request Type - Device to Host, Class, recipient is Device
	fredbuf[1] = 0x06;	// Request 		 - 06h = Get Descriptor
	fredbuf[2] = 0x00;	// Value ( low) - Descriptor Index
	fredbuf[3] = 0x01;	// Value ( high)- Descriptor Type
	fredbuf[4] = 0x00;	// Index ( low) - Zero
	fredbuf[5] = 0x00;	// Index ( high)- Zero
	fredbuf[6] = 0x12;	// Length( low) -
	fredbuf[7] = 0x00;	// Length( high)-
}

void get_device_descriptor( unsigned char address)
{
	address = address & 0x7f; // bits 8-14, not 8-15, so only 7 bits wide.
	// address goes into DW2, left shifted 8 bits

	generic_setup( address);


// FOURTH TD
	*(DW2 + 12)  = DW2_IN | DW2_DATA1_TOGGLE | (unsigned long) (2-1)<<21 | (unsigned char)(address)<<8;
}

void get_configuration_descriptor( unsigned char address)
{
	address = address & 0x7f; // bits 8-14, not 8-15, so only 7 bits wide.
	// address goes into DW2, left shifted 8 bits

	generic_setup( address);

// FOURTH TD
	*(DW0 + 12) = T_FLAG | first_transfer_descriptor + 64 | VF_FLAG;


// THIRD TD
	*(DW2 + 8) = DW2_IN | (unsigned long) (1-1)<<21 | (unsigned char)(address)<<8;
// FOURTH TD
	*(DW2 + 12) = DW2_OUT | DW2_DATA1_TOGGLE | (unsigned long) (0x7ff)<<21 | (unsigned char)(address)<<8;


	fredbuf[3] = 0x02;	// Value ( high)- Descriptor Type - 02 = Configuration
	fredbuf[6] = 0x09;	// Length( low) - 9 bytes
}

void get_interface_descriptor( unsigned char address)
{
// cannot get/set interface descriptors, can only get them through
// get/set configuration descriptor
	address = address & 0x7f; // bits 8-14, not 8-15, so only 7 bits wide.
	// address goes into DW2, left shifted 8 bits

	generic_setup( address);

// FOURTH TD
	*(DW0 + 12) = T_FLAG | first_transfer_descriptor + 64 | VF_FLAG;


// THIRD TD
	*(DW2 + 8) = DW2_IN | (unsigned long) (1-1)<<21 | (unsigned char)(address)<<8;
// FOURTH TD
	*(DW2 + 12) = DW2_OUT | DW2_DATA1_TOGGLE | (unsigned long) (0x7ff)<<21 | (unsigned char)(address)<<8;


// let's set up the setup packet to request the hub class descriptor
// which is descriptor 0.
	fredbuf[3] = 0x04;	// Value ( high)- Descriptor Type - 04 = Interface
	fredbuf[6] = 0x09;		// Length( low) - 9 bytes
}

void get_endpoint_descriptor( unsigned char address)
{
	address = address & 0x7f; // bits 8-14, not 8-15, so only 7 bits wide.
	// address goes into DW2, left shifted 8 bits

	generic_setup( address);

// THIRD TD
	*(DW0 + 8) = T_FLAG | first_transfer_descriptor + 48 | VF_FLAG;


// SECOND TD
	*(DW2 + 4) = DW2_IN | DW2_DATA1_TOGGLE | (unsigned long) (7-1)<<21 | (unsigned char)(address)<<8;
// THIRD TD
	*(DW2 + 8) = DW2_OUT | DW2_DATA1_TOGGLE  | (unsigned long) (0x7ff)<<21 | (unsigned char)(address)<<8;


// let's set up the setup packet to request the hub class descriptor
// which is descriptor 0.
	fredbuf[3] = 0x05;	// Value ( high)- Descriptor Type - 05 = Endpoint
	fredbuf[6] = 0x07;		// Length( low) - 9 bytes
}

void set_endpoint_descriptor( unsigned char address, unsigned char newendpoint)
{
	address = address & 0x7f; // bits 8-14, not 8-15, so only 7 bits wide.
	// address goes into DW2, left shifted 8 bits

	generic_setup( address);

	newendpoint = newendpoint & 0x0f; // endpoints are 4 bits, 15-18
	_fmemcpy( fredbuf, tempbuf, sizeof( tempbuf));


// THIRD TD
	*(DW0 + 8) = T_FLAG | first_transfer_descriptor + 48 | VF_FLAG;


// FIRST TD
	*DW2 = DW2_SETUP | (unsigned long) (8-1)<<21 | (unsigned char)(address)<<8;
// SECOND TD
	*(DW2 + 4) = DW2_OUT | DW2_DATA1_TOGGLE | (unsigned long) (7-1)<<21 | (unsigned char)(address)<<8;
// THIRD TD
	*(DW2 + 8) = DW2_IN | DW2_DATA1_TOGGLE  | (unsigned long) (0x7ff)<<21 | (unsigned char)(address)<<8;


// let's set up the setup packet to request the hub class descriptor
// which is descriptor 0.
	fredbuf[0] = 0x00;      // Request Type
	fredbuf[1] = 0x07;		// Request - Set Descriptor
	fredbuf[3] = 0x05;		// Value ( high)- Descriptor Type - 05 = Endpoint
	fredbuf[6] = 0x07;		// Length( low) - 9 bytes
}

void set_address( unsigned char address, unsigned char newaddress)
{
	address = address & 0x7f; // bits 8-14, not 8-15, so only 7 bits wide.
	// address goes into DW2, left shifted 8 bits

	newaddress = newaddress & 0x7f; // bits 8-14, not 8-15, so only 7 bits wide.
	// address goes into DW2, left shifted 8 bits

	generic_setup( address);

// SECOND TD
	*(DW0 + 4) = T_FLAG | first_transfer_descriptor + 32 | VF_FLAG;


// SECOND TD
	*(DW2 + 4) = DW2_IN | DW2_DATA1_TOGGLE | (unsigned long) (0x7ff)<<21 | (unsigned char)(address)<<8;


	fredbuf[0] = 0x00;	// Request Type - Device to Host, Class, recipient is Device
	fredbuf[1] = 0x05;	// Request 		 - 05h = Set Address
	fredbuf[2] = newaddress;		// Device Address
	fredbuf[3] = 0;		// Zero
	fredbuf[4] = 0;		// Zero
	fredbuf[5] = 0;		// Zero
	fredbuf[6] = 0;		// descriptor length in bytes
	fredbuf[7] = 0;		// same as above.

}

void get_data( unsigned char address, unsigned char endpoint)
{
	address = address & 0x7f; // bits 8-14, not 8-15, so only 7 bits wide.
	// address goes into DW2, left shifted 8 bits

	endpoint = endpoint & 0x0f; // bits 15-18 ( 4 bits), are the endpoint.

// FIRST TD
	*DW0 = T_FLAG | VF_FLAG;

// FIRST TD
// added Low Speed device flag for ALL DW1's, since Microsoft Keyboard
// is a LS device, the Cherry keyboard is not.
	*DW1 = DW1_LS | DW1_C_ERR3;

// FIRST TD
	*DW2 = DW2_IN | (unsigned long)(8-1)<<21 | (unsigned char)(address)<<8 | ( unsigned long) (endpoint)<<15;

// FIRST TD
	*DW3 = FP_SEG( fredbuf);
	*DW3 = *DW3 << 4;
	*DW3 = *DW3 + FP_OFF( fredbuf);
}

void get_configuration( unsigned char address)
{
	address = address & 0x7f; // bits 8-14, not 8-15, so only 7 bits wide.
	// address goes into DW2, left shifted 8 bits

// FIRST TD
	*DW0 = first_transfer_descriptor + 16 | VF_FLAG;
// SECOND TD
	*(DW0 + 4) = first_transfer_descriptor + 32 | VF_FLAG;
// THIRD TD
	*(DW0 + 8)  = T_FLAG | VF_FLAG;


// FIRST TD
// added Low Speed device flag for ALL DW1's, since Microsoft Keyboard
// is a LS device, the Cherry keyboard is not.
	*DW1 = DW1_LS | DW1_C_ERR3;
// SECOND TD
	*(DW1 + 4) = DW1_LS | DW1_C_ERR3;
// THIRD TD
	*(DW1 + 8)  = DW1_LS | DW1_C_ERR3;


// FIRST TD
	*DW2 = DW2_SETUP | (unsigned long)(8-1)<<21 | (unsigned char)(address)<<8;
// SECOND TD
	*(DW2 + 4) = DW2_IN | DW2_DATA1_TOGGLE | (unsigned long) (1-1)<<21 | (unsigned char)(address)<<8;
// THIRD TD
	*(DW2 + 8)  = DW2_OUT | DW2_DATA1_TOGGLE | (unsigned long) (0x7ff)<<21 | (unsigned char)(address)<<8;
// NOTE:!!!! FOR NULL PACKETS, YOU WILL ALWAYS CHOOSE DATA1 TOGGLED ON
// REGARDLESS OF THE CURRENT STATE OF DATA0 or DATA1!!!!


// FIRST TD
	*DW3 = FP_SEG( fredbuf);
	*DW3 = *DW3 << 4;
	*DW3 = *DW3 + FP_OFF( fredbuf);
// SECOND TD
// plus 8 bytes :)
	*(DW3 + 4) = *DW3 + 8;
// THIRD TD
// plus 8 bytes :)
	*(DW3 + 8) = *DW3 + 16;


	fredbuf[0] = 0x80;	// Request Type - Device to Host, Class, recipient is Device
	fredbuf[1] = 0x08;	// Request 		 - 06h = Get Descriptor
	fredbuf[2] = 0x00;   // Value ( low) - Descriptor Index
	fredbuf[3] = 0x00;	// Value ( high)- Descriptor Type
	fredbuf[4] = 0x00;	// Index ( low) - Zero
	fredbuf[5] = 0x00;	// Index ( high)- Zero
	fredbuf[6] = 0x01;	// Length( low) -
	fredbuf[7] = 0x00;	// Length( high)-
}

void set_configuration( unsigned char address, unsigned char newconfig)
{
	address = address & 0x7f; // bits 8-14, not 8-15, so only 7 bits wide.
	// address goes into DW2, left shifted 8 bits

// FIRST TD
	*DW0 = first_transfer_descriptor + 16 | VF_FLAG;
// SECOND TD
	*(DW0 + 4) = T_FLAG | VF_FLAG;


// FIRST TD
// added Low Speed device flag for ALL DW1's, since Microsoft Keyboard
// is a LS device, the Cherry keyboard is not.
	*DW1 = DW1_LS | DW1_C_ERR3;
// SECOND TD
	*(DW1 + 4) = DW1_LS | DW1_C_ERR3;


// FIRST TD
	*DW2 = DW2_SETUP | (unsigned long)(8-1)<<21 | (unsigned char)(address)<<8;
// SECOND TD
	*(DW2 + 4) = DW2_IN | DW2_DATA1_TOGGLE | (unsigned long) (0x7ff)<<21 | (unsigned char)(address)<<8;
// NOTE:!!!! FOR NULL PACKETS, YOU WILL ALWAYS CHOOSE DATA1 TOGGLED ON
// REGARDLESS OF THE CURRENT STATE OF DATA0 or DATA1!!!!


// FIRST TD
	*DW3 = FP_SEG( fredbuf);
	*DW3 = *DW3 << 4;
	*DW3 = *DW3 + FP_OFF( fredbuf);
// SECOND TD
// plus 8 bytes :)
	*(DW3 + 4) = *DW3 + 8;


	fredbuf[0] = 0x00;	// Request Type - Device to Host, Class, recipient is Device
	fredbuf[1] = 0x09;	// Request 		 - 06h = Get Descriptor
	fredbuf[2] = newconfig;// Value ( low) - Descriptor Index
	fredbuf[3] = 0x00;	// Value ( high)- Descriptor Type
	fredbuf[4] = 0x00;	// Index ( low) - Zero
	fredbuf[5] = 0x00;	// Index ( high)- Zero
	fredbuf[6] = 0x00;	// Length( low) -
	fredbuf[7] = 0x00;	// Length( high)-
}


void set_protocol( unsigned char address, unsigned char protocol)
{
	address = address & 0x7f; // bits 8-14, not 8-15, so only 7 bits wide.
	// address goes into DW2, left shifted 8 bits

// FIRST TD
	*DW0 = first_transfer_descriptor + 16 | VF_FLAG;
// SECOND TD
	*(DW0 + 4) = T_FLAG | VF_FLAG;


// FIRST TD
// added Low Speed device flag for ALL DW1's, since Microsoft Keyboard
// is a LS device, the Cherry keyboard is not.
	*DW1 = DW1_LS | DW1_C_ERR3;
// SECOND TD
	*(DW1 + 4) = DW1_LS | DW1_C_ERR3;


// FIRST TD
	*DW2 = DW2_SETUP | (unsigned long)(8-1)<<21 | (unsigned char)(address)<<8;
// SECOND TD
	*(DW2 + 4) = DW2_IN | DW2_DATA1_TOGGLE | (unsigned long) (0x7ff)<<21 | (unsigned char)(address)<<8;
// NOTE:!!!! FOR NULL PACKETS, YOU WILL ALWAYS CHOOSE DATA1 TOGGLED ON
// REGARDLESS OF THE CURRENT STATE OF DATA0 or DATA1!!!!


// FIRST TD
	*DW3 = FP_SEG( fredbuf);
	*DW3 = *DW3 << 4;
	*DW3 = *DW3 + FP_OFF( fredbuf);
// SECOND TD
// plus 8 bytes :)
	*(DW3 + 4) = *DW3 + 8;


	fredbuf[0] = 0x21;	// Request Type - Device to Host, Class, recipient is Device
	fredbuf[1] = 0x0b;	// Request 		 - 06h = Get Descriptor
	fredbuf[2] = protocol;// Value ( low) - Descriptor Index
	fredbuf[3] = 0x00;	// Value ( high)- Descriptor Type
	fredbuf[4] = 0x00;	// Index ( low) - Zero
	fredbuf[5] = 0x00;	// Index ( high)- Zero
	fredbuf[6] = 0x00;	// Length( low) -
	fredbuf[7] = 0x00;	// Length( high)-
}

void get_protocol( unsigned char address)
{
	address = address & 0x7f; // bits 8-14, not 8-15, so only 7 bits wide.
	// address goes into DW2, left shifted 8 bits

// FIRST TD
	*DW0 = first_transfer_descriptor + 16 | VF_FLAG;
// SECOND TD
	*(DW0 + 4) = first_transfer_descriptor + 32 | VF_FLAG;
// THIRD TD
	*(DW0 + 8)  = T_FLAG | VF_FLAG;


// FIRST TD
// added Low Speed device flag for ALL DW1's, since Microsoft Keyboard
// is a LS device, the Cherry keyboard is not.
	*DW1 = DW1_LS | DW1_C_ERR3;
// SECOND TD
	*(DW1 + 4) = DW1_LS | DW1_C_ERR3;
// THIRD TD
	*(DW1 + 8)  = DW1_LS | DW1_C_ERR3;


// FIRST TD
	*DW2 = DW2_SETUP | (unsigned long)(8-1)<<21 | (unsigned char)(address)<<8;
// SECOND TD
	*(DW2 + 4) = DW2_IN | DW2_DATA1_TOGGLE | (unsigned long) (1-1)<<21 | (unsigned char)(address)<<8;
// THIRD TD
	*(DW2 + 8)  = DW2_OUT | DW2_DATA1_TOGGLE | (unsigned long) (0x7ff)<<21 | (unsigned char)(address)<<8;
// NOTE:!!!! FOR NULL PACKETS, YOU WILL ALWAYS CHOOSE DATA1 TOGGLED ON
// REGARDLESS OF THE CURRENT STATE OF DATA0 or DATA1!!!!

// FIRST TD
	*DW3 = FP_SEG( fredbuf);
	*DW3 = *DW3 << 4;
	*DW3 = *DW3 + FP_OFF( fredbuf);
// SECOND TD
// plus 8 bytes :)
	*(DW3 + 4) = *DW3 + 8;
// THIRD TD
// plus 8 bytes :)
	*(DW3 + 8) = *DW3 + 16;

// since BOOT PROTOCOL returns 0, and our buffer is all 0's, we don't know
// if it worked, so setting first byte of IN from device to 0xff
fredbuf[8] = 0xff;


	fredbuf[0] = 0xa1;	// Request Type - Device to Host, Class, recipient is Device
	fredbuf[1] = 0x03;	// Request 		 - 06h = Get Descriptor
	fredbuf[2] = 0x00;	// Value ( low) - Descriptor Index
	fredbuf[3] = 0x00;	// Value ( high)- Descriptor Type
	fredbuf[4] = 0x00;	// Index ( low) - Zero
	fredbuf[5] = 0x00;	// Index ( high)- Zero
	fredbuf[6] = 0x01;	// Length( low) -
	fredbuf[7] = 0x00;	// Length( high)-
}

void set_interface( unsigned char address, unsigned char newinterface)
{
	address = address & 0x7f; // bits 8-14, not 8-15, so only 7 bits wide.
	// address goes into DW2, left shifted 8 bits

// FIRST TD
	*DW0 = first_transfer_descriptor + 16 | VF_FLAG;
// SECOND TD
	*(DW0 + 4) = T_FLAG | VF_FLAG;


// FIRST TD
// added Low Speed device flag for ALL DW1's, since Microsoft Keyboard
// is a LS device, the Cherry keyboard is not.
	*DW1 = DW1_LS | DW1_C_ERR3;
// SECOND TD
	*(DW1 + 4) = DW1_LS | DW1_C_ERR3;


// FIRST TD
	*DW2 = DW2_SETUP | (unsigned long)(8-1)<<21 | (unsigned char)(address)<<8;
// SECOND TD
	*(DW2 + 4) = DW2_IN | DW2_DATA1_TOGGLE | (unsigned long) (0x7ff)<<21 | (unsigned char)(address)<<8;
// NOTE:!!!! FOR NULL PACKETS, YOU WILL ALWAYS CHOOSE DATA1 TOGGLED ON
// REGARDLESS OF THE CURRENT STATE OF DATA0 or DATA1!!!!


// FIRST TD
	*DW3 = FP_SEG( fredbuf);
	*DW3 = *DW3 << 4;
	*DW3 = *DW3 + FP_OFF( fredbuf);
// SECOND TD
// plus 8 bytes :)
	*(DW3 + 4) = *DW3 + 8;


	fredbuf[0] = 0x01;	// Request Type - Device to Host, Class, recipient is Device
	fredbuf[1] = 0x11;	// Request 		 - 06h = Get Descriptor
	fredbuf[2] = newinterface;// Value ( low) - Descriptor Index
	fredbuf[3] = 0x00;	// Value ( high)- Descriptor Type
	fredbuf[4] = 0x00;	// Index ( low) - Zero
	fredbuf[5] = 0x00;	// Index ( high)- Zero
	fredbuf[6] = 0x00;	// Length( low) -
	fredbuf[7] = 0x00;	// Length( high)-
}

void get_interface( unsigned char address)
{
	address = address & 0x7f; // bits 8-14, not 8-15, so only 7 bits wide.
	// address goes into DW2, left shifted 8 bits

// FIRST TD
	*DW0 = first_transfer_descriptor + 16 | VF_FLAG;
// SECOND TD
	*(DW0 + 4) = first_transfer_descriptor + 32 | VF_FLAG;
// THIRD TD
	*(DW0 + 8)  = T_FLAG | VF_FLAG;


// FIRST TD
// added Low Speed device flag for ALL DW1's, since Microsoft Keyboard
// is a LS device, the Cherry keyboard is not.
	*DW1 = DW1_LS | DW1_C_ERR3;
// SECOND TD
	*(DW1 + 4) = DW1_LS | DW1_C_ERR3;
// THIRD TD
	*(DW1 + 8)  = DW1_LS | DW1_C_ERR3;


// FIRST TD
	*DW2 = DW2_SETUP | (unsigned long)(8-1)<<21 | (unsigned char)(address)<<8;
// SECOND TD
	*(DW2 + 4) = DW2_IN | DW2_DATA1_TOGGLE | (unsigned long) (1-1)<<21 | (unsigned char)(address)<<8;
// THIRD TD
	*(DW2 + 8)  = DW2_OUT | DW2_DATA1_TOGGLE | (unsigned long) (0x7ff)<<21 | (unsigned char)(address)<<8;
// NOTE:!!!! FOR NULL PACKETS, YOU WILL ALWAYS CHOOSE DATA1 TOGGLED ON
// REGARDLESS OF THE CURRENT STATE OF DATA0 or DATA1!!!!

// FIRST TD
	*DW3 = FP_SEG( fredbuf);
	*DW3 = *DW3 << 4;
	*DW3 = *DW3 + FP_OFF( fredbuf);
// SECOND TD
// plus 8 bytes :)
	*(DW3 + 4) = *DW3 + 8;
// THIRD TD
// plus 8 bytes :)
	*(DW3 + 8) = *DW3 + 16;

// since INTERFACE returns 0, and our buffer is all 0's, we don't know
// if it worked, so setting first byte of IN from device to 0xff
fredbuf[8] = 0xff;


	fredbuf[0] = 0x81;	// Request Type - Device to Host, Class, recipient is Device
	fredbuf[1] = 0x10;	// Request 		 - 06h = Get Descriptor
	fredbuf[2] = 0x00;	// Value ( low) - Descriptor Index
	fredbuf[3] = 0x00;	// Value ( high)- Descriptor Type
	fredbuf[4] = 0x00;	// Index ( low) - Zero
	fredbuf[5] = 0x00;	// Index ( high)- Zero
	fredbuf[6] = 0x01;	// Length( low) -
	fredbuf[7] = 0x00;	// Length( high)-
}

void clear_feature( unsigned char address, unsigned char feature, unsigned char index)
{
	address = address & 0x7f; // bits 8-14, not 8-15, so only 7 bits wide.
	// address goes into DW2, left shifted 8 bits

// FIRST TD
	*DW0 = first_transfer_descriptor + 16 | VF_FLAG;
// SECOND TD
	*(DW0 + 4) = T_FLAG | VF_FLAG;


// FIRST TD
// added Low Speed device flag for ALL DW1's, since Microsoft Keyboard
// is a LS device, the Cherry keyboard is not.
	*DW1 = DW1_LS | DW1_C_ERR3;
// SECOND TD
	*(DW1 + 4) = DW1_LS | DW1_C_ERR3;


// FIRST TD
	*DW2 = DW2_SETUP | (unsigned long)(8-1)<<21 | (unsigned char)(address)<<8;
// SECOND TD
	*(DW2 + 4) = DW2_IN | DW2_DATA1_TOGGLE | (unsigned long) (0x7ff)<<21 | (unsigned char)(address)<<8;
// NOTE:!!!! FOR NULL PACKETS, YOU WILL ALWAYS CHOOSE DATA1 TOGGLED ON
// REGARDLESS OF THE CURRENT STATE OF DATA0 or DATA1!!!!


// FIRST TD
	*DW3 = FP_SEG( fredbuf);
	*DW3 = *DW3 << 4;
	*DW3 = *DW3 + FP_OFF( fredbuf);
// SECOND TD
// plus 8 bytes :)
	*(DW3 + 4) = *DW3 + 8;


	if ( feature == DEVICE_REMOTE_WAKEUP)
		fredbuf[0] = 0x00;	// Request Type - Device to Host, Class, recipient is Device
	else if ( feature == ENDPOINT_STALL)
		fredbuf[0] = 0x02;	// Request Type - Device to Host, Class, recipient is Device
	fredbuf[1] = 0x01;	// Request 		 - 06h = Get Descriptor
	fredbuf[2] = feature;// Value ( low) - Descriptor Index
	fredbuf[3] = 0x00;	// Value ( high)- Descriptor Type
	fredbuf[4] = index;  // Index ( low) - Zero
	fredbuf[5] = 0x00;	// Index ( high)- Zero
	fredbuf[6] = 0x00;	// Length( low) -
	fredbuf[7] = 0x00;	// Length( high)-
}

void set_feature( unsigned char address, unsigned char feature, unsigned char index)
{
	address = address & 0x7f; // bits 8-14, not 8-15, so only 7 bits wide.
	// address goes into DW2, left shifted 8 bits

// FIRST TD
	*DW0 = first_transfer_descriptor + 16 | VF_FLAG;
// SECOND TD
	*(DW0 + 4) = T_FLAG | VF_FLAG;


// FIRST TD
// added Low Speed device flag for ALL DW1's, since Microsoft Keyboard
// is a LS device, the Cherry keyboard is not.
	*DW1 = DW1_LS | DW1_C_ERR3;
// SECOND TD
	*(DW1 + 4) = DW1_LS | DW1_C_ERR3;


// FIRST TD
	*DW2 = DW2_SETUP | (unsigned long)(8-1)<<21 | (unsigned char)(address)<<8;
// SECOND TD
	*(DW2 + 4) = DW2_IN | DW2_DATA1_TOGGLE | (unsigned long) (0x7ff)<<21 | (unsigned char)(address)<<8;
// NOTE:!!!! FOR NULL PACKETS, YOU WILL ALWAYS CHOOSE DATA1 TOGGLED ON
// REGARDLESS OF THE CURRENT STATE OF DATA0 or DATA1!!!!


// FIRST TD
	*DW3 = FP_SEG( fredbuf);
	*DW3 = *DW3 << 4;
	*DW3 = *DW3 + FP_OFF( fredbuf);
// SECOND TD
// plus 8 bytes :)
	*(DW3 + 4) = *DW3 + 8;


	if ( feature == DEVICE_REMOTE_WAKEUP)
		fredbuf[0] = 0x00;	// Request Type - Device to Host, Class, recipient is Device
	else if ( feature == ENDPOINT_STALL)
		fredbuf[0] = 0x02;	// Request Type - Device to Host, Class, recipient is Device
	fredbuf[1] = 0x03;	// Request 		 - 06h = Get Descriptor
	fredbuf[2] = feature;// Value ( low) - Descriptor Index
	fredbuf[3] = 0x00;	// Value ( high)- Descriptor Type
	fredbuf[4] = index;  // Index ( low) - Zero
	fredbuf[5] = 0x00;	// Index ( high)- Zero
	fredbuf[6] = 0x00;	// Length( low) -
	fredbuf[7] = 0x00;	// Length( high)-
}

void leds_set( unsigned char address, unsigned char num, unsigned char caps, unsigned char scroll)
{
	address = address & 0x7f; // bits 8-14, not 8-15, so only 7 bits wide.
	// address goes into DW2, left shifted 8 bits

// FIRST TD
	*DW0 = first_transfer_descriptor + 16 | VF_FLAG;
// SECOND TD
	*(DW0 + 4) = first_transfer_descriptor + 32 | VF_FLAG;
// THIRD TD
	*(DW0 + 8)  = T_FLAG | VF_FLAG;


// FIRST TD
// added Low Speed device flag for ALL DW1's, since Microsoft Keyboard
// is a LS device, the Cherry keyboard is not.
	*DW1 = DW1_LS | DW1_C_ERR3;
// SECOND TD
	*(DW1 + 4) = DW1_LS | DW1_C_ERR3;
// THIRD TD
	*(DW1 + 8)  = DW1_LS | DW1_C_ERR3;


// FIRST TD
	*DW2 = DW2_SETUP | (unsigned long)(8-1)<<21 | (unsigned char)(address)<<8;
// SECOND TD
	*(DW2 + 4) = DW2_OUT | DW2_DATA1_TOGGLE | (unsigned long) (1-1)<<21 | (unsigned char)(address)<<8;
// THIRD TD
	*(DW2 + 8)  = DW2_IN | DW2_DATA1_TOGGLE | (unsigned long) (0x7ff)<<21 | (unsigned char)(address)<<8;
// FIFTH TD
// NOTE:!!!! FOR NULL PACKETS, YOU WILL ALWAYS CHOOSE DATA1 TOGGLED ON
// REGARDLESS OF THE CURRENT STATE OF DATA0 or DATA1!!!!


// FIRST TD
	*DW3 = FP_SEG( fredbuf);
	*DW3 = *DW3 << 4;
	*DW3 = *DW3 + FP_OFF( fredbuf);
// SECOND TD
// plus 8 bytes :)
	*(DW3 + 4) = *DW3 + 8;
// let's set the LED's state.
fredbuf[8] = num | caps | scroll;
// THIRD TD
// plus 8 bytes :)
	*(DW3 + 8) = *DW3 + 16;


	fredbuf[0] = 0x21;	// Request Type - Device to Host, Class, recipient is Device
	fredbuf[1] = 0x09;	// Request 		 - 06h = Get Descriptor
	fredbuf[2] = 0x00;	// Value ( low) - Descriptor Index
	fredbuf[3] = 0x02;	// Value ( high)- Descriptor Type
	fredbuf[4] = 0x00;	// Index ( low) - Zero
	fredbuf[5] = 0x00;	// Index ( high)- Zero
	fredbuf[6] = 0x01;	// Length( low) -
	fredbuf[7] = 0x00;	// Length( high)-
}

void next_transaction()
{
	// at this point we could optionally turn on the "Q" or "T" bits in the
	// for this first frame list pointer, but the "Q" bit means it points to a
	// queuehead, which is does not, it points to a transfer descriptor, and
	// setting the "T" means that we don't follow the link that it points to.

	// now we need to modify DW0, DW1, DW2, DW3 of the first transfer
	// descriptor.
//void get_device_descriptor( unsigned char address)
//void get_configuration_descriptor( unsigned char address)

// cannot get/set interface descriptors, can only get them through
// get/set configuration descriptor

//void get_interface_descriptor( unsigned char address)
//void get_endpoint_descriptor( unsigned char address)

// WHY DO WE WANT TO SET THE ENDPOINT DESCRIPTOR?
// to change the characteristics of the endpoint? ( i.e. to receive data
//		instead of sending it?)

//void set_endpoint_descriptor( unsigned char address, unsigned char newendpoint)
//void set_address( unsigned char address, unsigned char newaddress)
//void get_data( unsigned char address, unsigned char endpoint)
//void get_configuration( unsigned char address)
//void set_configuration( unsigned char address, unsigned char newconfig)
//void set_protocol( unsigned char address, unsigned char protocol)
//void get_protocol( unsigned char address)
//void set_interface( unsigned char address, unsigned char newinterface)
//void get_interface( unsigned char address)
//void clear_feature( unsigned char address, unsigned char feature, unsigned char index)
	// index in the above is an ENDPOINT for ENDPOINT_STALL, for
	// DEVICE_REMOTE_WAKEUP it's a 0.
//void set_feature( unsigned char address, unsigned char feature, unsigned char index)
	// the above notes for get_feature() apply to set_feature()

	_fmemset( fredbuf, 0, sizeof( fredbuf));

max_transaction = 6;


	if ( current_transaction == 0)
	{
		set_address( 0, 1);
	}
	else if ( current_transaction == 1)
	{
		set_configuration( 1, 1);
	}
	else if ( current_transaction == 2)
	{
		get_configuration( 1);
	}
	else if ( current_transaction == 3)
	{
		set_protocol( 1, BOOT_PROTOCOL); // enable boot protocol mode
	}
	else if ( current_transaction == 4)
	{
		get_protocol( 1);
	}
	else if ( current_transaction == 5)
	{
		get_data( 1, 1);
	}

/*
	if ( current_transaction == 0)
	{
		get_configuration( 1);
	}
	else if ( current_transaction == 1)
	{
		get_protocol( 1);
	}
	else if ( current_transaction == 2)
	{
		leds_set( 1, NUM_LOCK_ON, 0, SCROLL_LOCK_ON);
	}
	else if ( current_transaction == 3)
	{
		leds_set( 1, NUM_LOCK_ON, 0, 0);
	}
	else if ( current_transaction == 4)
	{
		get_data( 1, 1);
	}
*/
}

void reset_usb_controller()
{
	outport( base_io, 0x0006);
	outport( base_io+0x10, inport( base_io+0x10) | 0x20);
	outport( base_io+0x12, inport( base_io+0x12) | 0x20);
	delay( 20);	// wait 10 milliseconds as per the spec.
	outport( base_io, 0x0000);
	outport( base_io+0x10, inport( base_io+0x10) & 0xdf);
	outport( base_io+0x12, inport( base_io+0x12) & 0xdf);
// we are now gonna write a 1 to bits 1 and 2 of the port we're using
// bit 1 clears the bit that says a device has just been connected
// bit 2 enables that device, assuming that the USB keyboard is being
// plugged into the top USB slot, if not, won't work... add detection
// later to read if bit 1 is set, then re-set it to a 1, and set bit 2
// to a 1

	int k;
	int looper;

	for ( looper = 0; looper <= 50; looper++)
	{
		k = inport( base_io+0x10);
		if ( ( k & 0x02) == 0)
			break;
		outport( base_io+0x10, inport( base_io+0x10) | 0x02);
	}
	k = inport( base_io+0x10);
	if ( ( k & 0x02) == 1)
	{
		puts("ERROR initializing port");
		getch();
		exit( 1);
	}
	outport( base_io+0x10, inport( base_io+0x10) | 0x04);
	k = inport( base_io+0x10);
// set it to running :)
	outport( base_io, 0x00c1);
	// set up Frame Number Register to 0
	// use ALL word IO writes to the IO ports, as per the spec.
	outport( base_io+4, 0);
	outport( base_io+6, 0);	// output a word 0 to port CCE6
	outport( base_io+8, ( unsigned int) (frame_list_base_address));
	outport( base_io+0xa, ( unsigned int) (frame_list_base_address>>16));
// mark add begin
	outport( base_io+0xc, 0x40);
}

int mouseon()
{
	union REGS regs;

	regs.x.ax = 0x0000;
	int86( 0x33, &regs, &regs);
	if ( regs.x.ax == 0000)
		return 1;
	regs.x.ax = 7;
	regs.x.cx = 0;
	regs.x.dx = 8*79;	   //( the minus ten is for the cursor size)
	int86( 0x33, &regs, &regs);
	regs.x.ax = 8;
	regs.x.cx = 0;
	regs.x.dx = 8*MAXBOX;       //( the minus ten is for the cursor size)
	int86( 0x33, &regs, &regs);

// positions cursor to 0, 0
	regs.x.ax = 4;
	regs.x.cx = 0;
	regs.x.dx = 0;
	int86( 0x33, &regs, &regs);

// turns off the cursor
	regs.h.ah = 1;
	regs.h.ch = 0x20;
	regs.h.cl = 0;
	int86( 0x10, &regs, &regs);
	return 0;
}

int mouseoff()
{
	union REGS regs;

	regs.x.ax = 0xc200;
	regs.h.bh = 0;
	int86( 0x33, &regs, &regs);
	if ( regs.x.cflag)
		return 1;
	return 0;
}

void getmouse()
{
	union REGS regs;

	regs.x.ax = 3;
	int86( 0x33, &regs, &regs);
	if ( regs.x.bx & 0x1)
		leftbutton = 1;
	else
		leftbutton = 0;
	if ( regs.x.bx & 0x2)
		rightbutton = 1;
	else
		rightbutton = 0;
	mousex = regs.x.cx;
	mousey = regs.x.dx;
	mousex = mousex / 8;
	mousex++;
	mousey = mousey / 8;
	mousey++;
}

void drawbox( int startx, int starty, int width, unsigned long far *p, int type)
{
	int looper;
	int fcolor, bcolor;
	unsigned long newaddr;
	unsigned char far *q1;

	switch (type)
	{
		case FRAME_LIST_TYPE:
			looper = 1;
			fcolor = BLACK;
			bcolor = GREEN;
			break;
		case QUEUE_HEAD_TYPE:
			looper = 2;
			fcolor = BLACK;
			bcolor = BLUE;
			break;
		case TRANSFER_DESCRIPTOR_TYPE:
			looper = 4;
			fcolor = BLACK;
			bcolor = RED;
			break;
		case DATA_TYPE:
			looper = 4;
			fcolor = BLACK;
			bcolor = LIGHTMAGENTA;
			break;
		default:
			return;

	}
	if ( type == DATA_TYPE)
	{
		textcolor( WHITE);
		textbackground( BLACK);
		gotoxy( startx+8, starty);
		newaddr = ( unsigned long) p;
		cprintf("%.8lX", newaddr);

		newaddr = ( newaddr & 0x00ffff0) << 12;
		p = ( unsigned long far *) ( newaddr + (( unsigned long) (p) & 0x000f));

		textcolor( fcolor);
		textbackground( bcolor);
		gotoxy( startx, starty+1);
		for ( int t = 0; t < width + 2; t++)
			cprintf("-");
		for ( t = 0; t < looper; t++)
		{
			for ( int s = 0; s < 8; s++)
			{
				q1 = ( unsigned char far *)p;
				gotoxy( startx+(s*3), starty+t+2);
				if ( s == 0)
					cprintf("|%.2X", *(q1+s+(t*8)));
				else if ( s == 7)
					cprintf("_%.2X|", *(q1+s+(t*8)));
				else
					cprintf("_%.2X", *(q1+s+(t*8)));
			}
		}
		gotoxy( startx, starty+looper+2);
		for ( t = 0; t < width + 2; t++)
		cprintf("-");
		textcolor( WHITE);
		textbackground( BLACK);
		return;
	}
	textcolor( WHITE);
	textbackground( BLACK);
	gotoxy( startx+3, starty);
	newaddr = ( unsigned long) p;
	newaddr = newaddr>>16;
	newaddr = newaddr<<4;
	newaddr = newaddr + ( (unsigned long)(p) & 0x0000ffff);
	cprintf("%.8lX", newaddr);

	textcolor( fcolor);
	textbackground( bcolor);
	gotoxy( startx, starty+1);
	for ( int t = 0; t < width + 2; t++)
		cprintf("-");
	for ( t = 0; t < looper; t++)
	{
		gotoxy( startx, starty+t+2);
//		if (( type == QUEUE_HEAD_TYPE) && ( t >= 2))
//			cprintf("|            |");
//		else
			cprintf("| 0x%.8lX |", *(p+t));
	}
	gotoxy( startx, starty+looper+2);
	for ( t = 0; t < width + 2; t++)
		cprintf("-");
	textcolor( WHITE);
	textbackground( BLACK);
}

void read_ports()
{
	// read the ports.
	gotoxy( 1, 10);
	cprintf("%.4X: %.4X\n", base_io, inport( base_io+0x0));
	gotoxy( 1, 11);
	cprintf("%.4X: %.4X\n", base_io+2, inport( base_io+0x2));
	gotoxy( 1, 12);
	cprintf("%.4X: %.4X\n", base_io+4, inport( base_io+0x4));
	gotoxy( 1, 13);
	cprintf("%.4X: %.4X\n", base_io+6, inport( base_io+0x6));
	gotoxy( 1, 14);
	cprintf("%.4X: %.4X%.4X\n", base_io+8, inport( base_io+0xa), inport( base_io+0x8));
	gotoxy( 1, 15);
	cprintf("%.4X: %.4X\n", base_io+0xc, inportb( base_io+0xc));
	gotoxy( 1, 16);
	cprintf("%.4X: %.4X\n", base_io+0x10, inport( base_io+0x10));
	gotoxy( 1, 17);
	cprintf("%.4X: %.4X\n", base_io+0x12, inport( base_io+0x12));
}


void draw_screen()
{
	unsigned long far *temp;
	int offset;
	unsigned long templ;

	drawbox( 1, 2, 12, frame_pointer, FRAME_LIST_TYPE);
// draw arrows from frame list to queue head
// don't draw arrows if link busted.
	if ( ( (*frame_pointer) & 0xfffffff0L) == first_queue_head)
	{
		gotoxy( 15, 4);
		cprintf("--------->");
	}
	else
	{
		gotoxy( 15, 4);
		cprintf("          ");
	}
	drawbox( 25, 2, 12, queue_pointer, QUEUE_HEAD_TYPE);

// at this point we keep drawing TD's till we run outta screen room or
// until we hit a TERMINATE bit set in one of the TD's

// check to see if the Queue Head has it's Terminate Bit set.
//	if (( (*(queue_pointer+1)) & 1) == 1)
//		return;

// draw arrow from first queue head to first TD.
// don't draw arrow if link busted.
	if ( ( (*( queue_pointer + 1)) & 0xfffffff0L) == first_transfer_descriptor)
	{
		gotoxy( 20, 5);
		cprintf("-----");
		for ( int t = 6; t <= 11; t++)
		{
			gotoxy( 20, t);
			cprintf("|");
		}
		gotoxy( 20, 12);
		cprintf("---->");
	}
	else
	{
		gotoxy( 20, 5);
		cprintf("     ");
		for ( int t = 6; t <= 11; t++)
		{
			gotoxy( 20, t);
			cprintf(" ");
		}
		gotoxy( 20, 12);
		cprintf("     ");
	}

//temp = DW0;
//templ = first_queue_head>>4;
//temp = ( unsigned long far *) MK_FP( templ,0);
//temp++;	// skip to the pointer that will point to a TD.
//templ = *temp;
templ = *(queue_pointer+1);
templ = templ>>4;
temp = ( unsigned long far *) MK_FP( templ, 0);
	offset = 10;
	while (1)
	{
		drawbox( 25, offset, 12, temp, TRANSFER_DESCRIPTOR_TYPE);
		drawbox( 50, offset, 23, ( unsigned long far *)(*(temp+3)), DATA_TYPE);
// draw arrow to data packet.
// we will always draw the arrow here, since we follow the pointer
// to this box.
		gotoxy( 39, offset+5);
		cprintf("---------->");

		if (( (*temp) & 1) == 1)
			break;
//		temp += 4;
templ = *temp;
templ = templ>>4;
temp = ( unsigned long far *) MK_FP( templ, 0);
		offset += 8;
		if ( offset >= MAXBOX)
			break;

// draw arrow
// we will always draw the arrow here, since we follow the pointer
// to this box.
		gotoxy( 20, offset+5-8);
		cprintf("-----");
		for ( int t = offset+6-8; t <= offset+9-8; t++)
		{
			gotoxy( 20, t);
			cprintf("|");
		}
		gotoxy( 20, offset+10-8);
		cprintf("---->");
	}
	read_ports();
}

void drawlist()
{
	char far *videoptr;
	static int oldmousex = 0, oldmousey = 0;

// if the mouse hasn't moved, don't update it.
	if (( mousex == oldmousex) && ( mousey == oldmousey))
	{
		gotoxy( mousex, mousey);
		cprintf("X");
		return;
	}

// restore text beneath old cursor position
	videoptr = ( char far *) MK_FP( 0xb800, (((oldmousey-1)*80)+(oldmousex-1))*2);
	*videoptr = tempchar;
	*(videoptr + 1) = tempattrib;

// save current text under current cursor position
	videoptr = ( char far *) MK_FP( 0xb800, (((mousey-1)*80)+(mousex-1))*2);
	tempchar = *videoptr;
	tempattrib = *( videoptr + 1);

	oldmousex = mousex;
	oldmousey = mousey;
	gotoxy( mousex, mousey);
	cprintf("X");

//	gotoxy( 1, 47);
//	cprintf("X: %d, Y: %d, OX: %d, OY: %d, CH: %c, Q & 1: %d                        \n", mousex, mousey, oldmousex, oldmousey, tempchar, *(queue_pointer) & 1);
}

int xconvert( char *temp, unsigned long *value)
{
	unsigned long multiplier = 1;
	int t;

	if ( ( temp[0] == '0') && ( temp[1] == 'X') &&
		  ( strlen( temp) <= 10))
	{
		*value = 0;
		for ( t = strlen( temp) - 1; t > 1; t--)
		{
			if ( ( temp[t] >= '0') && ( temp[t] <= '9'))
			{
				*value = *value + (( temp[t] - 48)*multiplier);
			}
			else if ( ( temp[t] >= 'A') && ( temp[t] <= 'F'))
			{
				*value = *value + (( temp[t] - 55)*multiplier);
			}
			else
			{
				gotoxy( 1, 48);
				clreol();
				gotoxy( 1, 49);
				clreol();
				return 0;
			}
			multiplier = multiplier << 4;
		}	// end for loop
		return 1;
	}	// end if
	return 0;
}

int hconvert( char *temp, unsigned long *value)
{
	unsigned long multiplier = 1;
	int t;

	if ( ( temp[strlen( temp)-1] == 'H') && ( strlen( temp) <= 9))
	{
		*value = 0;
		for ( t = strlen( temp) - 2; t > 1; t--)
		{
			if ( ( temp[t] >= '0') && ( temp[t] <= '9'))
			{
				*value = *value + (( temp[t] - 48) * multiplier);
			}
			else if ( ( temp[t] >= 'A') && ( temp[t] <= 'F'))
			{
				*value = *value + (( temp[t] - 55) * multiplier);
			}
			else
			{
				gotoxy( 1, 48);
				clreol();
				gotoxy( 1, 49);
				clreol();
				return 0;
			}
			multiplier = multiplier << 4;
		}
		return 1;
	}
	return 0;
}

void display_frame_list( unsigned long far *valuetoupdate)
{
	gotoxy( 1, 1);
	textcolor( BLACK);
	textbackground( LIGHTCYAN);
	 cprintf("----------------------------------------------------------------------------\n\r");
		 cprintf("| (31:3) %.8lX - 32 bit physical address pointer to Queue Head          |\n\r", (*valuetoupdate)&0xfffffffcL);
cprintf("| (1)           %.1lX - Queue Head Ptr?                                        |\n\r", ((*valuetoupdate)>>1)&0x00000001L);
cprintf("| (0)           %.1lX - Terminate?                                             |\n\r", (*valuetoupdate)&0x00000001L);
	 cprintf("|                                                                          |\n\r");
		 cprintf("|        %.8lX - current value                                          |\n\r", *valuetoupdate);
	 cprintf("----------------------------------------------------------------------------\n\r");
	textcolor( WHITE);
	textbackground( BLACK);
//	cprintf("                                                                            \n\r");
}

void display_dw0( unsigned long far *valuetoupdate)
{
	gotoxy( 1, 1);
	textcolor( BLACK);
	textbackground( LIGHTCYAN);
	 cprintf("----------------------------------------------------------------------------\n\r");
		 cprintf("| (31:4) %.8lX - 32 bit physical address pointer to Transfer Descriptor |\n\r", (*valuetoupdate)&0xfffffff0L);
cprintf("| (3)           %.1lX - Reserved supposed to be 0                              |\n\r", ((*valuetoupdate)>>3)&0x00000001L);
cprintf("| (2)           %.1lX - Vertical Flag?                                         |\n\r", ((*valuetoupdate)>>2)&0x00000001L);
cprintf("| (1)           %.1lX - Queue Head Ptr?                                        |\n\r", ((*valuetoupdate)>>1)&0x00000001L);
cprintf("| (0)           %.1lX - Terminate?                                             |\n\r", (*valuetoupdate)&0x00000001L);
	 cprintf("|                                                                          |\n\r");
		 cprintf("|        %.8lX - current value                                          |\n\r", *valuetoupdate);
	 cprintf("----------------------------------------------------------------------------\n\r");
	textcolor( WHITE);
	textbackground( BLACK);
//	cprintf("                                                                            \n\r");
}

void display_dw1( unsigned long far *valuetoupdate)
{
	gotoxy( 1, 1);
	textcolor( BLACK);
	textbackground( LIGHTCYAN);
	 cprintf("----------------------------------------------------------------------------\n\r");
cprintf("| (31:30)       %.1lX - Reserved ( not sure if 0 or 1)                         |\n\r", ((*valuetoupdate)>>30)&0x00000003L);
cprintf("| (29)          %.1lX - Short Packet Detect                                    |\n\r", ((*valuetoupdate)>>29)&0x00000001L);
cprintf("| (28:27)       %.1lX - Error Counter                                          |\n\r", ((*valuetoupdate)>>27)&0x00000003L);
cprintf("| (26)          %.1lX - Low Speed Device                                       |\n\r", ((*valuetoupdate)>>26)&0x00000001L);
cprintf("| (25)          %.1lX - Isochronous Select                                     |\n\r", ((*valuetoupdate)>>25)&0x00000001L);
cprintf("| (24)          %.1lX - Interrupt on Complete                                  |\n\r", ((*valuetoupdate)>>24)&0x00000001L);
cprintf("| (23)          %.1lX - Active                                                 |\n\r", ((*valuetoupdate)>>23)&0x00000001L);
cprintf("| (22)          %.1lX - Stalled                                                |\n\r", ((*valuetoupdate)>>22)&0x00000001L);
cprintf("| (21)          %.1lX - Data Buffer Error                                      |\n\r", ((*valuetoupdate)>>21)&0x00000001L);
cprintf("| (20)          %.1lX - Babble Detected                                        |\n\r", ((*valuetoupdate)>>20)&0x00000001L);
cprintf("| (19)          %.1lX - NAK Received                                           |\n\r", ((*valuetoupdate)>>19)&0x00000001L);
cprintf("| (18)          %.1lX - CRC/Timeout Error                                      |\n\r", ((*valuetoupdate)>>18)&0x00000001L);
cprintf("| (17)          %.1lX - Reserved                                               |\n\r", ((*valuetoupdate)>>17)&0x00000001L);
cprintf("| (16)          %.1lX - Reserved                                               |\n\r", ((*valuetoupdate)>>16)&0x00000001L);
 cprintf("| (15:11)      %.2lX - Reserved                                               |\n\r", ((*valuetoupdate)>>11)&0x0000001fL);
	cprintf("| (10:0)     %.4lX - Number of bytes transferred ( add 1 to this value)     |\n\r", (*valuetoupdate)&0x000007ffL);
	 cprintf("|                                                                          |\n\r");
		 cprintf("|        %.8lX - current value                                          |\n\r", *valuetoupdate);
	 cprintf("----------------------------------------------------------------------------\n\r");
	textcolor( WHITE);
	textbackground( BLACK);
//	cprintf("                                                                            \n\r");
}

void display_dw2( unsigned long far *valuetoupdate)
{
	gotoxy( 1, 1);
	textcolor( BLACK);
	textbackground( LIGHTCYAN);
	 cprintf("----------------------------------------------------------------------------\n\r");
	cprintf("| (31:21)    %.4lX - Maxiumum Length                                        |\n\r", ((*valuetoupdate)>>21)&0x000007ffL);
cprintf("| (20)          %.1lX - Reserved                                               |\n\r", ((*valuetoupdate)>>20)&0x00000001L);
cprintf("| (19)          %.1lX - Data Toggle                                            |\n\r", ((*valuetoupdate)>>19)&0x00000001L);
 cprintf("| (18:15)      %.2lX - EndPoint                                               |\n\r", ((*valuetoupdate)>>15)&0x0000000fL);
  cprintf("| (14:8)      %.3lX - Device Address                                         |\n\r", ((*valuetoupdate)>>8)&0x0000007fL);
  cprintf("| (7:0)       %.3lX - Packed ID (", (*valuetoupdate)&0x000000ffL);
  if ( ((*valuetoupdate)&0x000000ffL) == DW2_SETUP)
											  cprintf(" Setup Packet)                              |\n\r");
  else if ( ((*valuetoupdate)&0x000000ffL) == DW2_OUT)
											  cprintf(" Out Packet)                                |\n\r");
  else if ( ((*valuetoupdate)&0x000000ffL) == DW2_IN)
											  cprintf(" In Packet)                                 |\n\r");
  else
											  cprintf(" Unknown Packet)                            |\n\r");
	 cprintf("|                                                                          |\n\r");
		 cprintf("|        %.8lX - current value                                          |\n\r", *valuetoupdate);
	 cprintf("----------------------------------------------------------------------------\n\r");
	textcolor( WHITE);
	textbackground( BLACK);
//	cprintf("                                                                            \n\r");
}

void display_dw3( unsigned long far *valuetoupdate)
{
	gotoxy( 1, 1);
	textcolor( BLACK);
	textbackground( LIGHTCYAN);
	 cprintf("----------------------------------------------------------------------------\n\r");
		 cprintf("|        %.8lX - 32 bit physical address pointer to Buffer              |\n\r", *valuetoupdate);
	 cprintf("----------------------------------------------------------------------------\n\r");
	textcolor( WHITE);
	textbackground( BLACK);
//	cprintf("                                                                            \n\r");
}

void display_qh1( unsigned long far *valuetoupdate)
{
	gotoxy( 1, 1);
	textcolor( BLACK);
	textbackground( LIGHTCYAN);
	 cprintf("----------------------------------------------------------------------------\n\r");
		 cprintf("| (31:4) %.8lX - 32 bit physical address pointer to Transfer Descriptor |\n\r", (*valuetoupdate)&0xfffffff0L);
cprintf("| (3)           %.1lX - Reserved supposed to be 0                              |\n\r", ((*valuetoupdate)>>3)&0x00000001L);
cprintf("| (2)           %.1lX - Vertical Flag?                                         |\n\r", ((*valuetoupdate)>>2)&0x00000001L);
cprintf("| (1)           %.1lX - Queue Head Ptr?                                        |\n\r", ((*valuetoupdate)>>1)&0x00000001L);
cprintf("| (0)           %.1lX - Terminate?                                             |\n\r", (*valuetoupdate)&0x00000001L);
	 cprintf("|                                                                          |\n\r");
		 cprintf("|        %.8lX - current value                                          |\n\r", *valuetoupdate);
	 cprintf("----------------------------------------------------------------------------\n\r");
	textcolor( WHITE);
	textbackground( BLACK);
//	cprintf("                                                                            \n\r");
}

void print_setup( unsigned long far *valuetoupdate)
{
	unsigned char far *p;

	p = ( unsigned char far *) MK_FP( ( unsigned int) (*(valuetoupdate+2) >> 4 ), ( unsigned int) (*(valuetoupdate+2) & 0xf ));
	gotoxy( 1, 1);
	textcolor( BLACK);
	textbackground( LIGHTCYAN);
	 cprintf("----------------------------------------------------------------------------\n\r");
cprintf("| (0 bit 7)      %.1X - Data Transfer Direction ( %s)             |\n\r", ((*p)>>7)&1, (((*p)>>7)&1) == 0 ? "Host to device" : "Device to Host");
cprintf("| (0 bit 6:5)    %.1X - Type of Setup Transaction ( %9s)                |\n\r", ((*p)>>5)&0x3, (((*p)>>5)&3) == 0 ? "Standard" : (((*p)>>5)&0x3) == 1 ? "Class" : (((*p)>>5)&0x3) == 2 ? "Vendor" : "Reserved");
cprintf("| (0 bit 4:0)   %.2X - Recipient ( %9s)                                |\n\r", (*p)&0x1f, ((*p)&0x1f) == 0 ? "Device" : ((*p)&0x1f) == 1 ? "Interface" : ((*p)&0x1f) == 2 ? "Endpoint" : ((*p)&0x1f) == 3 ? "Other" : "Reserved");
cprintf("| (1)           %.2X - Specific Request ( %17s)                 |\n\r", (*(p+1)), (*(p+1)) == 0 ? "Get Status" : (*(p+1)) == 1 ? "Clear Feature" : (*(p+1)) == 3 ? "Set Feature" : (*(p+1)) == 5 ? "Set Address" : (*(p+1)) == 6 ? "Get Descriptor" : (*(p+1)) == 7 ? "Set Descriptor" : (*(p+1)) == 8 ? "Get Configuration" : (*(p+1)) == 9 ? "Set Configuration" : (*(p+1)) == 0x10 ? "Get Interface" : (*(p+1)) == 0x11 ? "Set Interface" : (*(p+1)) == 0x12 ? "Synch Frame" : "Unknown");
cprintf("| (2)           %.2X - ( %17s)                                  |\n\r", (*(p+2)), (*(p+1)) == 0 ? "Zero" : (*(p+1)) == 1 ? "Feature Selector" : (*(p+1)) == 3 ? "Feature Selector" : (*(p+1)) == 5 ? "Device Address" : (*(p+1)) == 6 ? "Descriptor Index" : (*(p+1)) == 7 ? "Descriptor Index" : (*(p+1)) == 8 ? "Zero" : (*(p+1)) == 9 ? "Zero" : (*(p+1)) == 0x10 ? "Zero" : (*(p+1)) == 0x11 ? "Alternate Setting" : (*(p+1)) == 0x12 ? "Zero" : "Unknown");
cprintf("| (3)           %.2X - ( %17s)  %16s                |\n\r", (*(p+3)), (*(p+1)) == 0 ? "Zero" : (*(p+1)) == 1 ? "Feature Selector" : (*(p+1)) == 3 ? "Feature Selector" : (*(p+1)) == 5 ? "Device Address" : (*(p+1)) == 6 ? "Descriptor Type" : (*(p+1)) == 7 ? "Descriptor Type" : (*(p+1)) == 8 ? "Zero" : (*(p+1)) == 9 ? "Zero" : (*(p+1)) == 0x10 ? "Zero" : (*(p+1)) == 0x11 ? "Alternate Setting" : (*(p+1)) == 0x12 ? "Zero" : "Unknown", ((*(p+1)) >= 6) && ((*(p+1)) <= 7) && ((*(p+3))==1) ? "( Device)       " : ((*(p+1)) >= 6) && ((*(p+1)) <= 7) && ((*(p+3))==2) ? "( Configuration)" : ((*(p+1)) >= 6) && ((*(p+1)) <= 7) && ((*(p+3))==3) ? "( String)       " : ((*(p+1)) >= 6) && ((*(p+1)) <= 7) && ((*(p+3))==4) ? "( Interface)    " : ((*(p+1)) >= 6) && ((*(p+1)) <= 7) && ((*(p+3))==5) ? "( Endpoint)     " : "                ");
cprintf("| (4)           %.2X - Zero ( low byte)                                      |\n\r", (*(p+4)));
cprintf("| (5)           %.2X - Zero ( high byte)                                     |\n\r", (*(p+5)));
cprintf("| (6)           %.2X - Length ( low byte)                                    |\n\r", (*(p+6)));
cprintf("| (7)           %.2X - Length ( high byte)                                   |\n\r", (*(p+7)));
	 cprintf("----------------------------------------------------------------------------\n\r");
	textcolor( WHITE);
	textbackground( BLACK);
//	cprintf("                                                                            \n\r");
	getch();
}

void print_outin_packet_info( unsigned long far *valuetoupdate)
{
	print_setup( valuetoupdate);
//	getch();
}

char no_error( unsigned long far *valuetoupdate)
{
	if ( ( ( (*valuetoupdate)>>16) & 0x7f) == 0)
		return 1;
	else
		return 0;
}

char no_data_sent( unsigned long far *valuetoupdate)
{
	if ( ( (*valuetoupdate) & 0x7ff) == 0)
		return 1;
	else
		return 0;
}

void display_data_type( unsigned long far *valuetoupdate)
{
	if (   ((*(valuetoupdate+1) & 0xff) == DW2_SETUP)  ) // &&
//		( no_error( valuetoupdate))  &&
//		( no_data_sent( valuetoupdate))  )
	{
		print_setup( valuetoupdate);
	}
	else if (   ((*(valuetoupdate+1) & 0xff) == DW2_IN) &&
		( no_error( valuetoupdate))  &&
		( !no_data_sent( valuetoupdate))  )
	{
		print_outin_packet_info( valuetoupdate);
	}
	else if (   ((*(valuetoupdate+1) & 0xff) == DW2_OUT) &&
		( no_error( valuetoupdate))  &&
		( no_data_sent( valuetoupdate))  )
	{
		print_outin_packet_info( valuetoupdate);
	}
}

void print_fields( unsigned long far *valuetoupdate, int type)
{
	switch ( type)
	{
		case FRAME_LIST_TYPE:
			display_frame_list( valuetoupdate);
			break;
		case DW0_TYPE:
			display_dw0( valuetoupdate);
			break;
		case DW1_TYPE:
			display_dw1( valuetoupdate);
			break;
		case DW2_TYPE:
			display_dw2( valuetoupdate);
			break;
		case DW3_TYPE:
			display_dw3( valuetoupdate);
			break;
		case QH1_TYPE:
			display_qh1( valuetoupdate);
			break;
		case DATA_TYPE:
			display_data_type( valuetoupdate);
		default:
			break;
	}
}

void do_stuff( unsigned long far *valuetoupdate, int type)
{
	char temp[255];
	unsigned long newvalue;                                                      \
	int t;
	unsigned char far *tempptr;

	print_fields( valuetoupdate, type);
	if ( type == DATA_TYPE)
	{
		clrscr();
		draw_screen();
		tempptr = ( char far *) MK_FP( 0xb800, (((mousey-1)*80)+(mousex-1))*2);
		tempchar = *tempptr;
		tempattrib = *(tempptr + 1);
		return;
	}
	cprintf("%c", 7);
	gotoxy( 1, 48);
	cprintf("New value> ");
	gets( temp);
	strupr( temp);
	if ( xconvert( temp, &newvalue))
	{
	}
//	else if ( hconvert( temp, &newvalue))
//	{
//	}
	else
	{
		newvalue = atol( temp);
// bogus value?
//gotoxy( 1, 49);
//cprintf("%d %d %d %d\n\r", temp[0], temp[1], temp[2], temp[3]);
//getch();
		if ( newvalue == 0)
		{
			if ( strlen( temp) == 0)
			{
					gotoxy( 1, 48);
					clreol();
					gotoxy( 1, 49);
					clreol();
clrscr();
draw_screen();
					return;
			}
			for ( t = 0; t < strlen( temp); t++)
			{
				if ( temp[t] != '0')
				{
					gotoxy( 1, 48);
					clreol();
					gotoxy( 1, 49);
					clreol();
clrscr();
draw_screen();
					return;
				}
			}
		}
	}

	gotoxy( 1, 48);
	clreol();

	*valuetoupdate = newvalue;
//	drawbox( 1, 2, 12, frame_pointer, FRAME_LIST_TYPE);
clrscr();
	draw_screen();
	tempptr = ( char far *) MK_FP( 0xb800, (((mousey-1)*80)+(mousex-1))*2);
	tempchar = *tempptr;
	tempattrib = *(tempptr + 1);
}

void checkifoverbox()
{
	unsigned long far *temp;

// check to see if frame list box clicked on
	if ( ( mousex >= 1) && ( mousex <= 14) && ( mousey >= 4) &&
		  ( mousey <= 4) )
	{
		do_stuff( frame_pointer, FRAME_LIST_TYPE);
	}
/* don't let them update the first dword in the queue_head
	else if ( ( mousex >= 25) && ( mousex <= 38) && ( mousey >= 4) &&
		  ( mousey <= 4) )
	{
		do_stuff( frame_pointer);
	}
*/
	else if ( ( mousex >= 25) && ( mousex <= 38) && ( mousey >= 5) &&
		  ( mousey <= 5) )
	{
		do_stuff( queue_pointer+1, QH1_TYPE);
	}
	else
	{
		temp = DW0;
		for ( int t = 10; t <= MAXBOX; t+=8)
		{
			if ( ( mousex >= 25) && ( mousex <= 38) && ( mousey >= t+2) &&
			     ( mousey <= t+2) )
				  do_stuff( temp, DW0_TYPE);
			else if ( ( mousex >= 25) && ( mousex <= 38) && ( mousey >= t+3) &&
				( mousey <= t+3) )
				  do_stuff( temp+1, DW1_TYPE);
			else if ( ( mousex >= 25) && ( mousex <= 38) && ( mousey >= t+4) &&
				  ( mousey <= t+4) )
				  do_stuff( temp+2, DW2_TYPE);
			else if ( ( mousex >= 25) && ( mousex <= 38) && ( mousey >= t+5) &&
				  ( mousey <= t+5) )
				  do_stuff( temp+3, DW3_TYPE);
			else if ( ( mousex >= 50) && ( mousex <= 83) &&
				  ( mousey >= t+1) && ( mousey <= t+6) )
				  // pass in DW1, so we can check error and
				  // bytes sent bits.
				  // pass DW2 so we can see if we were getting
				  // data with an IN, or doing a SETUP or OUT.
				  do_stuff( temp+1, DATA_TYPE);

			// TERMINATE?
			if (( (*temp) & 1) == 1)
				break;
			// follow pointer from DW0 in current Transfer Descriptor
			templ = *temp;
			templ = templ>>4;
			temp = ( unsigned long far *) MK_FP( templ, 0);
		}
	}

//	drawbox( 25, offset, 12, temp, TRANSFER_DESCRIPTOR_TYPE);
}

#define START 	0
#define END		1

void _time( char mode)
{
	static unsigned long starttime, endtime;
	unsigned long elap2;
	double elapsed;

/*
	asm {
		db 0x0f, 0xa2
	}
	return;

*/
	if ( mode == START)
	{
		asm {
			db 0x0f, 0x31								// RDTSC
			mov	word ptr [starttime], ax
			db	0x66, 0xc1, 0xe8, 0x10				// SHR EAX, 16
			mov	word ptr [starttime+2], ax
		}
	}
	else if ( mode == END)
	{
		asm {
			db 0x0f, 0x31								// RDTSC
			mov	word ptr [endtime], ax
			db	0x66, 0xc1, 0xe8, 0x10				// SHR EAX, 16
			mov	word ptr [endtime+2], ax
		}
		elapsed = endtime - starttime;
		elapsed = elapsed / 400.0f; // 400 MHz system
		elapsed = elapsed + 5;
		elap2 = elapsed;
		elapsed = elap2 / 1000.0f;
		printf("Elapsed time: %f milliseconds\n", elapsed);
	}
}

void do_trans()
{
		// we keep them from accessing our TD's as we modify them
		// wait 20 milliseconds to make sure the host controller
		// starts hitting the terminate bit, and isn't currently
		// past it, and on the TD's right after it.
		*DW1 = *DW1 | DW1_ACTIVE;
		*(DW1 + 4) = *(DW1 + 4) | DW1_ACTIVE;
		*(DW1 + 8) = *(DW1 + 8) | DW1_ACTIVE;
		*(DW1 + 12) = *(DW1 + 12) | DW1_ACTIVE;
		*(DW1 + 16) = *(DW1 + 16) | DW1_ACTIVE;
		*(queue_pointer + 1) = QH1;
		// re-point the QH to the first TD, and let it take 20 milliseconds
		// to notice this and execute it.

		delay( 20);
		// restore the real QH pointer to the first TD.
		*(queue_pointer + 1) = QH1 | T_FLAG;
}

void on_error( unsigned char numtds, char *errorstr)
{
	unsigned long errors;
	int t;
	int doexit = 0;
	// check to see if any error bits set on the number of TD's specified.

	errors = *DW1;
	for ( t = 0; t < numtds; t++)
	{
		errors = errors >> 16;
		errors = errors & 0x0000007F;
		if ( errors != 0)
		{
			printf("%s\n", errorstr);
			printf("TD: %d\n", t);
			printf("\tDW0: %.8lX\n", *(DW0 + (t*4)));
			printf("\tDW1: %.8lX\n", *(DW1 + (t*4)));
			if ( (*(DW1 + (t*4))) & RESERVED_BIT16)
				printf("\t\tReserved bit 16 error\n");
			if ( (*(DW1 + (t*4))) & BIT_STUFF_ERROR)
				printf("\t\tBit Stuff Error\n");
			if ( (*(DW1 + (t*4))) & CRC_TIME_OUT_ERROR)
				printf("\t\tCRC or Time Out Error\n");
			if ( (*(DW1 + (t*4))) & NAK)
				printf("\t\tNAK\n");
			if ( (*(DW1 + (t*4))) & BABBLE_ERROR)
				printf("\t\tBabble Detected\n");
			if ( (*(DW1 + (t*4))) & DATA_BUFFER_ERROR)
				printf("\t\tData Buffer Error\n");
			if ( (*(DW1 + (t*4))) & STALLED_ERROR)
				printf("\t\tStalled\n");
			printf("\tDW2: %.8lX\n", *(DW2 + (t*4)));
			printf("\tDW3: %.8lX\n", *(DW3 + (t*4)));
			doexit = 1;
		}
		errors = *(DW1 + (t*4));
	}
	if ( doexit)
	{
		mouseoff();
		exit( 0);
	}
}

void initialize()
{
	_time( START);
// need to _fmemset on fredbuf, if we send data to the device
	set_address( 0, 1);
	do_trans();
	on_error(2, "set address error");

	set_configuration( 1, 1);
	do_trans();
	on_error( 2, "set configuration error");

	set_protocol( 1, BOOT_PROTOCOL);
	do_trans();
	on_error(2, "set protocol error");

	_time( END);

	current_transaction = 0;
//	next_transaction();
}

void loop_through()
{
	char ch = 'a';

	current_transaction = 0;
	next_transaction();
	draw_screen();
	gotoxy( 1, 48);
	cprintf("QH1: %lX", QH1);
	while( 1)
	{
		read_ports();
		if ( kbhit())
			ch = getch();
		getmouse();
		if ( leftbutton)
			checkifoverbox();
		drawlist();
		if ( ch == 'r')
		{
			cprintf("%c", 7);
			// we'll turn the active bit on from now on.
// mark add begin
// let's try NOT using the debug method
//outport( base_io, inport( base_io) | 0x0001);
//outport( base_io, 0x0001);
//			outport( base_io, inport( base_io) | 0x0021);
//			outport( base_io, inport( base_io) | 0x0021);
//			outport( base_io, inport( base_io) | 0x0021);


//			*(queue_pointer + 1) = T_FLAG;
			// we keep them from accessing our TD's as we modify them
			// wait 20 milliseconds to make sure the host controller
			// starts hitting the terminate bit, and isn't currently
			// past it, and on the TD's right after it.
//			delay( 5);
			*DW1 = *DW1 | DW1_ACTIVE;
			*(DW1 + 4) = *(DW1 + 4) | DW1_ACTIVE;
			*(DW1 + 8) = *(DW1 + 8) | DW1_ACTIVE;
			*(DW1 + 12) = *(DW1 + 12) | DW1_ACTIVE;
			*(DW1 + 16) = *(DW1 + 16) | DW1_ACTIVE;
			*(queue_pointer + 1) = QH1;
			// re-point the QH to the first TD, and let it take 20 milliseconds
			// to notice this and execute it.
			delay( 5);
			// restore the real QH pointer to the first TD.
			*(queue_pointer + 1) = QH1 | T_FLAG;
			// save contents of returned data
			_fmemcpy( tempbuf, fredbuf, sizeof( tempbuf));
			draw_screen();
		}
		else if ( ch == ' ')
		{
			current_transaction++;
			if ( current_transaction >= max_transaction)
				current_transaction = 0;
			*(queue_pointer + 1) = T_FLAG;
			// we keep them from accessing our TD's as we modify them
			// wait 20 milliseconds to make sure the host controller
			// starts hitting the terminate bit, and isn't currently
			// past it, and on the TD's right after it.
			delay( 5);
			next_transaction();
			clrscr();
			*(queue_pointer + 1) = QH1;
			// re-point the QH to the first TD, and let it take 20 milliseconds
			// to notice this and execute it.
			delay( 5);
			// restore the real QH pointer to the first TD.
			*(queue_pointer + 1) = QH1;
			draw_screen();
		}
		else if ( ch == 27)
			break;
		ch = 'a';
	}
}

void do_in( unsigned char address, unsigned char endpoint, unsigned char datatoggle)
{
	address = address & 0x7f; // bits 8-14, not 8-15, so only 7 bits wide.
	// address goes into DW2, left shifted 8 bits

	endpoint = endpoint & 0x0f; // bits 15-18 ( 4 bits), are the endpoint.

// 1 bit
//	datatoggle = datatoggle & 1;
//printf("TOGGLE: %d\n", datatoggle);

// FIRST TD
	*DW0 = T_FLAG | VF_FLAG;

// FIRST TD
// added Low Speed device flag for ALL DW1's, since Microsoft Keyboard
// is a LS device, the Cherry keyboard is not.
*DW1 = DW1_LS | DW1_C_ERR3;

// FIRST TD
	*DW2 = DW2_IN | (unsigned long)(8-1)<<21 | (unsigned long)(address)<<8 | ( unsigned long) (endpoint)<<15 | ( unsigned long) (datatoggle)<<19;

// FIRST TD
	*DW3 = FP_SEG( fredbuf);
	*DW3 = *DW3 << 4;
	*DW3 = *DW3 + FP_OFF( fredbuf);
}

void translate_key( unsigned char key)
{
	static xkey = 1, ykey = 2;

	if ( ( key >= 0x04) && ( key <= 0x1d))
	{
//		gotoxy( xkey, ykey);
		printf("%c", key+97-4);
	}
	else if ( key == 0x28)
		printf("\n\r");
	else if ( key == 0x2c)
		printf(" ");
	else if ( key == 0x2a)
		printf("%c", 7);
	xkey++;
	if ( xkey > 80)
	{
		xkey = 1;
		ykey++;
	}
}

void print_data()
{
	unsigned char t;

/*
	printf("DW2: %lX\n", *DW2);
	printf("DW1: %lX\n", *DW1);
	printf("     ");
	for ( t = 0; t < 8; t++)
	{
		printf("%.2X ", fredbuf[t]);
	}
	printf("\n");
*/
/*
	if ( fredbuf[0] & LEFT_CTRL)
		printf("LEFT CONTROL\t");

	if ( fredbuf[0] & LEFT_SHIFT)
		printf("LEFT SHIFT\t");

	if ( fredbuf[0] & LEFT_ALT)
		printf("LEFT ALT\t");

	if ( fredbuf[0] & LEFT_GUI)
		printf("LEFT GUI\t");

	if ( fredbuf[0] & RIGHT_CTRL)
		printf("RIGHT CONTROL\t");

	if ( fredbuf[0] & RIGHT_SHIFT)
		printf("RIGHT SHIFT\t");

	if ( fredbuf[0] & RIGHT_ALT)
		printf("RIGHT ALT\t");

	if ( fredbuf[0] & RIGHT_GUI)
		printf("RIGHT GUI\t");

	if ( fredbuf[0] != 0)
		printf("\n");
*/
	for ( t = 2; t < 7; t++)
	{
		translate_key( fredbuf[t]);
	}
}

void free_run()
{
	unsigned long templ;
	unsigned char current_toggle = 0;


// initialize the USB keyboard.
	initialize();


// set up frame list to make every 8th frame list pointer point to our QUEUE
// don't forget our first queue head has it's TD pointer set with the Terminate
// FLAG, thiis keeps us from running TD's until we're ready.
	for ( templ = 0; templ < 1024; templ++)
	{
		if ( (templ % 8) == 0)
			*(frame_pointer+templ) = first_queue_head | Q_FLAG;
		else
			*(frame_pointer+templ) = T_FLAG | Q_FLAG;
	}

	printf("Starting transactions...\n");

// setup IN transaction from DEVICE.
	while ( 1)
	{
		_time( START);
		do_in( 1, 1, current_toggle);

		*DW1 = *DW1 | DW1_ACTIVE;
		*(queue_pointer + 1) = QH1;
		// re-point the QH to the first TD, and let it take 20 milliseconds
		// to notice this and execute it.

		while ( ((*DW1) & DW1_ACTIVE) != 0)
		{
//			if ( ( ( *DW1) & NAK) != 0)
//			{
//				printf("NAK!!!!!!\n");
//				break;
//			}
			if ( (*DW1) & 0x00770000)
			{
				on_error( 1, "IN!!!!");
				break;
			}
			if ( kbhit())
				break;
		}


		while ( (*(queue_pointer+1)) == QH1)
		{
//			if ( ( ( *DW1) & NAK) != 0)
//			{
//				printf("NAK!!!!!!\n");
//				break;
//			}
			if ( (*DW1) & 0x00770000)
			{
				on_error( 1, "IN!!!!");
				break;
			}
			if ( kbhit())
				break;
		}

		// restore the real QH pointer to the first TD.
		*(queue_pointer + 1) = QH1 | T_FLAG;


		print_data();
		if ( kbhit())
			break;
		current_toggle++;
		current_toggle = current_toggle & 1;
		_time( END);
	}
	getch();
	mouseoff();
	exit( 0);
}

void drawscreen()
{
	textcolor( WHITE);
	textbackground( BLACK);
	clrscr();
	if ( mouseon())
	{
		puts("Unable to use mouse driver");
		exit( 0);
	}
// loop through, allows you to do single transactions, and check the results
// from each.
      loop_through();
//        free_run();

	mouseoff();
	clrscr();
	exit( 0);
}


